/******************************************************************************
*
* @brief  PMC ͷļ.  
*
******************************************************************************/
#ifndef PMC_H_
#define PMC_H_
#ifdef __cplusplus
extern "C" {
#endif

#include "common.h"
/******************************************************************************
* PCMϵͳMCUģʽģʽ
*
*******************************************************************************/
#define PmcModeRun     0                     /*!< ģʽ */
#define PmcModeWait    1                     /*!< ȵģʽ */
#define PmcModeStop4   2                     /*!< ֹͣģʽ4 */
#define PmcModeStop3   3                     /*!< ֹͣģʽ3 */


/******************************************************************************
* PMC ѹ͵ѹѹ
*
*******************************************************************************/
#define PmcLVDTrip_Low   0                     /*!< LVD ͵ƽ */
#define PmcLVDTrip_High  1                     /*!< LVD ߵƽ */

#define PmcLVWTrip_Low   0                     /*!< LVW ͵ƽ */
#define PmcLVWTrip_Mid1  1                     /*!< LVW мƽ1 */
#define PmcLVWTrip_Mid2  2                     /*!< LVW мƽ2*/
#define PmcLVWTrip_High  3                     /*!< LVW ߵƽ*/

/******************************************************************************
* PMC ƽṹ
*******************************************************************************/
/*!
 * @brief PMCƽṹ
 *
 */

typedef union 
{
   uint8_t byte;						  /*!< -ֽ*/
   struct 
   {     
       uint8_t bBandgapEn        :1;      /*!< ʹܴ϶ */
       uint8_t bBandgapDrv       :1;      /*!< ѡ϶*/
       uint8_t bLvdEn            :1;      /*!< ʹܵѹ*/
       uint8_t bLvdStopEn        :1;      /*!< ѹֹͣģʽʹ*/
       uint8_t bLvdRstEn         :1;      /*!< ʹܵѹ⸴λ */
       uint8_t bLvwIrqEn         :1;      /*!< ʹܵѹж */
       uint8_t bLvwAck           :1;      /*!< ѹӦ */
       uint8_t bLvwFlag          :1;      /*!< ѹ־ */
   }bits; 								                /*!< -λ */
}PMC_Ctrl1Type, *PMC_Ctrl1Ptr;		  /*!< PMC ƼĴ1ṹ */


/******************************************************************************
* PMC -- ѹѡ.
*******************************************************************************/
/*!
 * @brief PMC -- ѹѡ.
 *
 */
typedef union 
{
   uint8_t byte;						   /*!< -ֽ */
   struct 
   {     
       uint8_t           :4;               /*!< none */  
       uint8_t bLVWV     :2;               /*!< ѹѹѡ */  
       uint8_t bLVDV     :1;               /*!< ѹλѹѡ */  
       uint8_t           :1;               /*!< none */                 
   }bits;  								   /*!< ṹ͡λ */
}PMC_Ctrl2Type, *PMC_Ctrl2Ptr;		   /*!< PMC ƼĴ2ṹ*/

/******************************************************************************
* PMC ýṹ
*******************************************************************************/

typedef struct 
{
    PMC_Ctrl1Type    sCtrlstatus;          /*!< PMC ƺ״̬ */  
    PMC_Ctrl2Type    sDetectVoltSelect;    /*!< ѹѹ͵ѹλѹѡ*/  
}PMC_ConfigType, *PMC_ConfigPtr;		   /*!< PMC ýṹ */

/*****************************************************************************//*!
*
* @brief  ֹͣģʽʹܵѹ.
* 
* @param[in]  pPMC              ָPMCģ
*
* @return none.
*
* @see PMC_DisableLVDInStopMode.
*
*****************************************************************************/
__STATIC_INLINE void PMC_EnableLVDInStopMode(PMC_Type *pPMC)
{
    pPMC->SPMSC1 |= PMC_SPMSC1_LVDSE_MASK;
}

/*****************************************************************************//*!
*
* @brief  ֹͣģʽ½õѹ
* 
* @param[in]  pPMC           ָPMCģ
*
* @return none.
*
* @see PMC_EnableLVDInStopMode.
*
*****************************************************************************/
__STATIC_INLINE void PMC_DisableLVDInStopMode(PMC_Type *pPMC)
{
    pPMC->SPMSC1 &= ~PMC_SPMSC1_LVDSE_MASK;
}

/*****************************************************************************//*!
*
* @brief  ʹܵѹ⸴λ  ע: λֶνдһ
* 
* @param[in]  pPMC           ָPMCģ.
*
* @return none.
*
* @see PMC_DisableLVDRst.
*
*****************************************************************************/
__STATIC_INLINE void PMC_EnableLVDRst(PMC_Type *pPMC)
{
    pPMC->SPMSC1 |= PMC_SPMSC1_LVDRE_MASK;
}

/*****************************************************************************//*!
*
* @brief  õѹ⸴λ   ע: λֶνдһ
* 
* @param[in]  pPMC             ָPMCģ
*
* @return none.
*
* @see PMC_EnableLVDRst.
*
*****************************************************************************/
__STATIC_INLINE void PMC_DisableLVDRst(PMC_Type *pPMC)
{
    pPMC->SPMSC1 &= ~PMC_SPMSC1_LVDRE_MASK;
}

/*****************************************************************************//*!
*
* @brief  ʹܵѹ,  ע: λֶνдһ
* 
* @param[in]  pPMC            ָPMCģ
*
* @return none.
*
* @see PMC_DisableLVD.
*
*****************************************************************************/
__STATIC_INLINE void PMC_EnableLVD(PMC_Type *pPMC)
{
    pPMC->SPMSC1 |= PMC_SPMSC1_LVDE_MASK;
}

/*****************************************************************************//*!
*
* @brief  õѹ,   ע: λֶνдһ
* 
* @param[in]  pPMC           ָPMCģ
*
* @return none.
*
* @see PMC_EnableLVD.
*
*****************************************************************************/
__STATIC_INLINE void PMC_DisableLVD(PMC_Type *pPMC)
{
    pPMC->SPMSC1 &= ~PMC_SPMSC1_LVDE_MASK;
}

/*****************************************************************************//*!
*
* @brief   õѹ㣬
* 
* @param[in]  pPMC              ָPMCģ
* @param[in]  Trippoint         ѹѡ1-ߵƽ 0-͵ƽ
*
* @return none.
*
* @see PMC_SetLVWTripVolt.
*
*****************************************************************************/
__STATIC_INLINE void PMC_SetLVDTripVolt(PMC_Type *pPMC, uint8_t Trippoint)
{
    if(Trippoint)
        pPMC->SPMSC2 |= PMC_SPMSC2_LVDV_MASK;
    else
        pPMC->SPMSC2 &= ~PMC_SPMSC2_LVDV_MASK;
}

/*****************************************************************************//*!
*
* @brief  ѡѹѹ
* 
* @param[in]  pPMC              ָPMCģ
* @param[in]  Trippoint         ѹѹ  0 ͵ƽ     1 мƽ1 
*                                                   2 мƽ2  3 ߵƽ
*
* @return none.
*
* @see PMC_SetLVDTripVolt.
*
*****************************************************************************/
__STATIC_INLINE void PMC_SetLVWTripVolt(PMC_Type *pPMC, uint8_t Trippoint)
{
    pPMC->SPMSC2 &= ~PMC_SPMSC2_LVWV_MASK;
    pPMC->SPMSC2 |= PMC_SPMSC2_LVWV(Trippoint);
}

/*****************************************************************************//*!
*
* @brief  ʹܵѹж
* 
* @param[in]  pPMC        ָPMCģ
*
* @return none.
*
* @see PMC_DisableLVWInterrupt.
*
*****************************************************************************/
__STATIC_INLINE void PMC_EnableLVWInterrupt(PMC_Type *pPMC)
{
   pPMC->SPMSC1 |= PMC_SPMSC1_LVWIE_MASK;
}

/*****************************************************************************//*!
*
* @brief õѹж
* 
* @param[in]  pPMC              ָPMCģ.
*
* @return none.
*
*
* @see PMC_EnableLVWInterrupt.
*
*****************************************************************************/
__STATIC_INLINE void PMC_DisableLVWInterrupt(PMC_Type *pPMC)
{
   pPMC->SPMSC1 &= ~PMC_SPMSC1_LVWIE_MASK;
}

/*****************************************************************************//*!
*
* @brief  ȡѹ־λ.
* 
* @param[in]  pPMC           ָPMCģ.
*
* @return  ѹ־λֵ
*
* @see PMC_ClrLVWFlag.
*
*****************************************************************************/
__STATIC_INLINE uint8_t PMC_GetLVWFlag(PMC_Type *pPMC)
{
   return (pPMC->SPMSC1 & PMC_SPMSC1_LVWF_MASK);
}

/*****************************************************************************//*!
*
* @brief  ѹ־λ
* 
* @param[in]  pPMC            ָPMCģ.
*
* @return none.
*
* @see PMC_GetLVWFlag.
*
*****************************************************************************/
__STATIC_INLINE void PMC_ClrLVWFlag(PMC_Type *pPMC)
{
   pPMC->SPMSC1 |= PMC_SPMSC1_LVWACK_MASK;
}  

/**************************************************************************/

void PMC_Init(PMC_Type *pPMC, PMC_ConfigType *pPMC_Config);
void PMC_DeInit(PMC_Type *pPMC);
void PMC_SetMode(PMC_Type *pPMC,uint8_t u8PmcMode);

#ifdef __cplusplus
}
#endif
#endif 
