/*************************************************************************!     
 *     ۣQQȺ  123763203
 *         www.navota.com
 *
 * @file       bos.h
 * @brief      λ洢ģ飨BOS)
 * @author     Navota
 * @date       2017-1-1
 ***************************************************************************/
/******************************************************************************
******************************************************************************/

#ifndef __BOS_H
#define __BOS_H
#ifdef __cplusplus
extern "C" {
#endif
/******************************************************************************
*
* BOS 루opcode
*
*******************************************************************************/

#define BOS_OPCODE_AND		1               /*!< AND  */
#define BOS_OPCODE_OR		2               /*!< OR  */
#define BOS_OPCODE_XOR		3               /*!< XOR  */
#define BOS_OPCODE_BITFIELD	4               /*!< λֶβ */

#define BOS_OPCODE_BIT_CLEAR    2           /*!< λ */
#define BOS_OPCODE_BIT_SET      3           /*!< λ */


/******************************************************************************
*
* BOS궨壬BOSӲַ
*
*******************************************************************************/

/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/

/*****************************************************************************//*!
   *
   * @brief  BOSλ߼ַ32λӲַ
   *        
   * @param[in]   ADDR  32λַ.
   *  
   * @return  hardcoded  32λַ.
   *
   *
*****************************************************************************/
#define BOS_AND(ADDR)           (*(volatile uint32_t *)(((uint32_t)ADDR) | (BOS_OPCODE_AND<<26)))  

/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/

/*****************************************************************************//*!
   *
   * @brief  BOSλ߼ַ32λӲַ
   *        
   * @param[in]   ADDR  32λַ.
   *  
   * @return  hardcoded 32λַ.
   *
*****************************************************************************/

#define BOS_OR(ADDR)           (*(volatile uint32_t *)(((uint32_t)ADDR) | (BOS_OPCODE_OR<<26)))     


/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/

/*****************************************************************************//*!
   *
   * @brief  BOSλ߼ַ32λӲַ
   *        
   * @param[in]   ADDR  32λַ.
   *  
   * @return  hardcoded 32λַ.
   *
*****************************************************************************/

#define BOS_XOR(ADDR)           (*(volatile uint32_t *)(((uint32_t)ADDR) | (BOS_OPCODE_XOR<<26)))   

#if !defined(BOS_SANITY_CHECK)
/*!
 * @brief This is fastest way for BOS without sanity check.
 */
/******************************************************************************
 * 궨壬һλ-㣨LAC1Ӳַ.
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ1λַ32λӲַ
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit     Ҫλ, 0-based.
 *  
 * @return  hardcoded 32-bit address.
 *
*****************************************************************************/
    
    #define BOS_BIT_CLEAR(ADDR,bit)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit)<<21)))                                                

/******************************************************************************
 * 궨壬һλ-λLAS1Ӳַ. 
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ1λλַ32λӲַ
 *        
 * @param[in]   ADDR  32λַ.
 * @param[in]   bit     Ҫ1λ, 0-based.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/
    #define BOS_BIT_SET(ADDR,bit)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit)<<21)))                                                

/******************************************************************************
 *궨壬λ洢ֶβ(BFI)Ӳַ. 
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ洢ֶβӲַ (32λӲַ).
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit    ֶεʼλ, 0-based.
 * @param[in]   width  ֶεĿ,   1-based.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/    
    #define BOS_BITFIELD_INSERT(ADDR,bit,width)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit)<<23) | ((width-1))<<19))                        


/******************************************************************************
 * *궨壬λ洢޷ֶȡ(UBFX)Ӳַ .
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  λ洢޷ֶȡ(UBFX)ַ  (32λӲַ).
 *        
 * @param[in]   ADDR  32λַ.
 * @param[in]   bit    ȡʼλ,   0-based.
 * @param[in]   width  ȡֶο, 1-based.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/    

   #define BOS_BITFIELD_EXTRACT(ADDR,bit,width)        (*(volatile uint32_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit)<<23) | ((width-1))<<19))                            
#else
/*!
 * @brief This is slow way for BOS as it has sanity check.
 */
/******************************************************************************
 * 궨壬һλ-㣨LAC1ַ.
 *
 *******************************************************************************/
    #define BOS_BIT_CLEAR(ADDR,bit)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit & 0x1F)<<21)))                                                /*!< λ */

/*****************************************************************************
 * 궨壬һλ-λLAS1Ӳַ.
 *
 *******************************************************************************/
    #define BOS_BIT_SET(ADDR,bit)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit & 0x1F)<<21)))                                                /*!< λ */

/******************************************************************************
 *궨壬λ洢ֶβ(BFI)Ӳַ.
 *
 *******************************************************************************/
   #define BOS_BITFIELD_INSERT(ADDR,bit,width)        (*(volatile uint32_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))                        /*!< ֶβ */


/******************************************************************************
 *궨壬λ洢޷ֶȡ(UBFX)Ӳַ
 *
 *******************************************************************************/
 #define BOS_BITFIELD_EXTRACT(ADDR,bit,width)        (*(volatile uint32_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))                        /*!< ֶȡ */
#endif
/******************************************************************************
*  BOS궨壬BOSӲַ8λַ
*
*******************************************************************************/

/******************************************************************************
* 궨壬߼Ӳַ.8λַ
*
*******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ߼루ANDַ32λӲַ8λݽ
 *        
 * @param[in]   ADDR  32λַ.
 *  
 * @return  hardcoded 32-bit address.
 *
*****************************************************************************/

#define BOS_AND_8b(ADDR)           (*(volatile uint8_t *)(((uint32_t)ADDR) | (BOS_OPCODE_AND<<26)))   

/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ߼ORַ32λӲַ8λݽл.
 *        
 * @param[in]   ADDR  32λַ.
 *  
 * @return  hardcoded 32λַ.
 *
*****************************************************************************/

#define BOS_OR_8b(ADDR)           (*(volatile uint8_t *)(((uint32_t)ADDR) | (BOS_OPCODE_OR<<26)))    

/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/

/*****************************************************************************//*!
 *
 * @brief  BOSλ߼XORַ32λӲַ8λݽ..
 *        
 * @param[in]   ADDR  32λַ.
 *  
 * @return  hardcoded 32λַ.
 *
*****************************************************************************/

#define BOS_XOR_8b(ADDR)           (*(volatile uint8_t *)(((uint32_t)ADDR) | (BOS_OPCODE_XOR<<26)))   

#if !defined(BOS_SANITY_CHECK)
     /*!
         * @brief This is fastest way for BOS without sanity check.
         */
/******************************************************************************
* 궨 1λ㣨LAC1Ӳַ
*
*******************************************************************************/

/*****************************************************************************//*!
 *
 * @brief  BOSλ1λַ32λӲַ8λݲ.
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit    Ҫλ, 0-based.
 *  
 * @return  hardcoded 32λַ.
 *
*****************************************************************************/
 #define BOS_BIT_CLEAR_8b(ADDR,bit)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit)<<21)))                                                

/******************************************************************************
 * 궨 1λ1LAS1Ӳַ
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *           
 * @brief BOSλ1λ1LAS1)루32λӲַ8λݲ
 *        
 * @param[in]   ADDR 32λַ
 * @param[in]   bit  Ҫ1λ, 0-based.
 *  
 * @return  hardcoded 32λַ.
 *
 *****************************************************************************/
    
 #define BOS_BIT_SET_8b(ADDR,bit)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit)<<21)))                                                

/******************************************************************************
 *궨壬λ洢ֶβ(BFI)Ӳַ.
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ洢ֶβӲַ (32λӲַ).8λݲ
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit    ֶεʼλ, 0-based.
 * @param[in]   width  ֶεĿ,   1-based.
 *  
 * @return  hardcoded 32λַ.
 *
 *****************************************************************************/       

    #define BOS_BITFIELD_INSERT_8b(ADDR,bit,width)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit)<<23) | ((width-1))<<19))                        
/******************************************************************************
 *궨壬λ洢޷ֶȡ(UBFX)Ӳַ .
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  λ洢޷ֶȡ(UBFX)ַ  (32λӲַ).8λ
 *        
 * @param[in]   ADDR  32λַ.
 * @param[in]   bit    ȡʼλ,   0-based.
 * @param[in]   width  ȡֶο, 1-based.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/        
   #define BOS_BITFIELD_EXTRACT_8b(ADDR,bit,width)        (*(volatile uint8_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit<<23) | ((width-1))<<19))                        
#else
/*!
 * @brief This is slow way for BOS as it has sanity check.
 */
/******************************************************************************
 * 궨壬һλ-㣨LAC1ַ.
 *
 *******************************************************************************/
 #define BOS_BIT_CLEAR_8b(ADDR,bit)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit & 0x1F)<<21)))                                      /*!< λ8λģʽ*/

/******************************************************************************
 * 궨壬һλ-λLAS1Ӳַ.
 *
 *******************************************************************************/
    #define BOS_BIT_SET_8b(ADDR,bit)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit & 0x1F)<<21)))                                      /*!< λ18λģʽ*/

/******************************************************************************
 * 궨壬λ洢ֶβ(BFI)Ӳַ.
 *
 *******************************************************************************/
   #define BOS_BITFIELD_INSERT_8b(ADDR,bit,width)        (*(volatile uint8_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))              /*!< ֶβ8λģʽ */

/******************************************************************************
 *궨壬λ洢޷ֶȡ(UBFX)Ӳַ
 *******************************************************************************/

    #define BOS_BITFIELD_EXTRACT_8b(ADDR,bit,width)        (*(volatile uint8_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))              /*!< ֶȡ8λ */
#endif


/******************************************************************************
*  BOS궨壬BOSӲַ16λַ
*
*******************************************************************************/

/******************************************************************************
* 궨壬߼Ӳַ.16λַ
*
*******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  BOSλ߼루ANDַ32λӲַ8λݽ
 *        
 * @param[in]   ADDR  32λַ.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/

#define BOS_AND_16b(ADDR)           (*(volatile uint16_t *)(((uint32_t)ADDR) | (BOS_OPCODE_AND<<26)))   

/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/
/*****************************************************************************//*!
   *
   * @brief  BOSλ߼ORַ32λӲַ8λݽл.
   *        
   * @param[in]   ADDR  32λַ.
   *  
   * @return  hardcoded 32λַ.
   *
*****************************************************************************/

#define BOS_OR_16b(ADDR)           (*(volatile uint16_t *)(((uint32_t)ADDR) | (BOS_OPCODE_OR<<26)))    


/******************************************************************************
* 궨壬߼Ӳַ.
*
*******************************************************************************/

/*****************************************************************************//*!
 *
 * @brief  BOSλ߼XORַ32λӲַ8λݽ..
 *        
 * @param[in]   ADDR  32λַ.
 *  
 * @return  hardcoded 32λַ.
 *
 ***************************************************************************/

#define BOS_XOR_16b(ADDR)           (*(volatile uint16_t *)(((uint32_t)ADDR) | (BOS_OPCODE_XOR<<26)))   


#if !defined(BOS_SANITY_CHECK)
/*!
 * @brief This is fastest way for BOS without sanity check.
 */

/******************************************************************************
* 궨 1λ㣨LAC1Ӳַ
*
*******************************************************************************/

/*****************************************************************************//*!
 *
 * @brief  BOSλ1λַ32λӲַ16λݲ.
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit    Ҫλ, 0-based.
 *  
 * @return  hardcoded 32λַ.
 *
 ****************************************************************************/
    
    #define BOS_BIT_CLEAR_16b(ADDR,bit)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit)<<21)))                                               

/******************************************************************************
 * 궨 1λ1LAS1Ӳַ
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *           
 * @brief BOSλ1λ1LAS1)루32λӲַ8λݲ
 *        
 * @param[in]   ADDR 32λַ
 * @param[in]   bit  Ҫ1λ, 0-based.
 *  
 * @return  hardcoded 32λַ.
 *
 *****************************************************************************/  
   #define BOS_BIT_SET_16b(ADDR,bit)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit)<<21)))                                                

 /******************************************************************************
  *궨壬λ洢ֶβ(BFI)Ӳַ.
  *
 *******************************************************************************/

/*****************************************************************************//*!
 *
 * @brief  BOSλ洢ֶβӲַ (32λӲַ).16λݲ
 *        
 * @param[in]   ADDR  32λַ
 * @param[in]   bit    ֶεʼλ, 0-based.
 * @param[in]   width  ֶεĿ,   1-based.
 *  
 * @return  hardcoded 32λַ.
 *
 *****************************************************************************/         
    
    #define BOS_BITFIELD_INSERT_16b(ADDR,bit,width)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit)<<23) | ((width-1))<<19))                        

/******************************************************************************
 *궨壬λ洢޷ֶȡ(UBFX)Ӳַ .
 *
 *******************************************************************************/
/*****************************************************************************//*!
 *
 * @brief  λ洢޷ֶȡ(UBFX)ַ  (32λӲַ).16λ
 *        
 * @param[in]   ADDR  32λַ.
 * @param[in]   bit    ȡʼλ,   0-based.
 * @param[in]   width  ȡֶο, 1-based.
 *  
 * @return  hardcoded 32-bit address.
 *
 *****************************************************************************/       

 #define BOS_BITFIELD_EXTRACT_16b(ADDR,bit,width)        (*(volatile uint16_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit)<<23) | ((width-1))<<19))                        
#else
/*!
 * @brief This is slow way for BOS as it has sanity check.
 */
/******************************************************************************
 * 궨壬һλ-㣨LAC1ַ.
 *
 *******************************************************************************/
   #define BOS_BIT_CLEAR_16b(ADDR,bit)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_CLEAR <<26)  \
                                  | ((bit & 0x1F)<<21)))                                               /*!< λ16λģʽ*/

/******************************************************************************
 * 궨壬һλ-λLAS1Ӳַ.
 *
 *******************************************************************************/
   #define BOS_BIT_SET_16b(ADDR,bit)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BIT_SET <<26)  \
                                  | ((bit & 0x1F)<<21)))                                                /*!< λ116λģʽ*/

/******************************************************************************
 * 궨壬λ洢ֶβ(BFI)Ӳַ.
 *
 *******************************************************************************/
   #define BOS_BITFIELD_INSERT_16b(ADDR,bit,width)        (*(volatile uint16_t *)(((uint32_t)ADDR)   \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))                        /*!< ֶβ16λģʽ */

/******************************************************************************
 *궨壬λ洢޷ֶȡ(UBFX)Ӳַ
 *******************************************************************************/
   #define BOS_BITFIELD_EXTRACT_16b(ADDR,bit,width)        (*(volatile uint16_t *)(((uint32_t)ADDR)    \
                                  | (BOS_OPCODE_BITFIELD <<26)  \
                                  | ((bit & 0x1F)<<23) | ((width-1) & 0xF)<<19))                         /*!< ֶȡ16λ */
#endif

#ifdef __cplusplus
}
#endif
#endif 


