/*****************************************************************************!     
 *     ۣQQȺ  123763203
 *         www.navota.com
 *
 * @file       etm.c
 * @brief      etmʱ
 * @author     Navota
 * @date       2018-3-1
 ***************************************************************************/

#include "common.h"
#include "etm.h"


/*!
 * @brief Żص
 *
 */
ETM_CallbackPtr ETM_Callback[3] = {(ETM_CallbackPtr)NULL};


/******************************************************************************
* ETMĽӿں
*******************************************************************************/

/*******************************************************************************//*!
*
* @brief ETMģʱԴƵϵ.
*        
* @param[in]    pETM                  ָETMʱһĻַ.
* @param[in]    ClockSource           ETM ѡʱԴ  ãETM_CLOCK_NOCLOCKϵͳʱӣETM_CLOCK_SYSTEMCLOCK̶Ƶʱ/2ETM_CLOCK_FIXEDFREQCLOCKʱӣETM_CLOCK_EXTERNALCLOCK.
* @param[in]    ClockPrescale         Ƶϵ.
*
* @return none.
*
*********************************************************************************/
void ETM_ClockSet(ETM_Type *pETM, uint8_t u8ClockSource, uint8_t u8ClockPrescale)
{
    uint8_t   u8Temp;
    u8Temp  = (pETM->SC & 0xE0);//pETMָSCĴ5λ0δѡʱӣʱȡ1Ƶ
    u8Temp |= (ETM_SC_CLKS(u8ClockSource & 0x3) | ETM_SC_PS(u8ClockPrescale & 0x7));
    pETM->SC = u8Temp;//øETM״̬ƼĴETMx_SC
}

/*********************************************************************************//*!
*
* @brief  ETMPWMĳʼ 
*        
* @param[in]    pETM                  ָETMʱһĻַ.
* @param[in]    PWMModeSelect         жCPWM10ضEPWM01ԼģʽPWM11.
* @param[in]    PWMEdgeSelect         壨01壨10.
*
* @return none.
*
*********************************************************************************/
void ETM_PWMInit(ETM_Type *pETM, uint8_t u8PWMModeSelect, uint8_t u8PWMEdgeSelect)
{
    uint8_t   channels, i;
    
    ASSERT((ETM0== pETM) || (ETM1== pETM) || (ETM2== pETM));//ETMͨǷȷ
    
    /* ѡETMʱ */
	if (ETM0 == pETM)
    {
        channels = 2;
        SIM->SCGC |= SIM_SCGC_ETM0_MASK; //ETM0ͨ
    }
    else if(ETM1 == pETM) 
    {
        channels = 2;
        SIM->SCGC |= SIM_SCGC_ETM1_MASK;  //ETM1ͨ
    }        
    else
    {
        channels = 6;
        SIM->SCGC  |= SIM_SCGC_ETM2_MASK; //ETM2ͨ
    }
    
    pETM->SC  = 0x0;                                   //رռ
		pETM->MOD = ETM_MOD_INIT; 
    
    if(ETM_PWMMODE_CENTERALLIGNED == u8PWMModeSelect)   //CPWM
    {
        pETM->SC |= ETM_SC_CPWMS_MASK; 
    }
    else if(ETM_PWMMODE_COMBINE == u8PWMModeSelect)    
    {
        ASSERT(ETM2 == pETM);
        pETM->MODE    |= ETM_MODE_WPDIS_MASK | ETM_MODE_ETMEN_MASK;
        pETM->COMBINE = ETM_COMBINE_COMBINE0_MASK | ETM_COMBINE_COMP0_MASK | ETM_COMBINE_SYNCEN0_MASK | ETM_COMBINE_DTEN0_MASK |
                        ETM_COMBINE_COMBINE1_MASK | ETM_COMBINE_COMP1_MASK | ETM_COMBINE_SYNCEN1_MASK | ETM_COMBINE_DTEN1_MASK |
                        ETM_COMBINE_COMBINE2_MASK | ETM_COMBINE_COMP2_MASK | ETM_COMBINE_SYNCEN2_MASK | ETM_COMBINE_DTEN2_MASK 
                        ;    // ͨģʽ 
        pETM->SC &= ~ETM_SC_CPWMS_MASK; 
    }
    if(ETM_PWM_HIGHTRUEPULSE == u8PWMEdgeSelect)
    {
      /* ͨĴͨ״ֵ̬ͨ */
        for(i=0; i<channels; i++)
        {
            pETM->CONTROLS[i].CnSC = ETM_CnSC_MSB_MASK | ETM_CnSC_ELSB_MASK;  
            pETM->CONTROLS[i].CnV  = ETM_C0V_INIT + i*100; 
        }
    }
    else if(ETM_PWM_LOWTRUEPULSE == u8PWMEdgeSelect)
    {
        for(i=0; i<channels; i++) 
        {
            pETM->CONTROLS[i].CnSC = ETM_CnSC_MSB_MASK | ETM_CnSC_ELSA_MASK; 
            pETM->CONTROLS[i].CnV  = ETM_C0V_INIT + i*100 ; 
        }
    }  
}

/*********************************************************************************//*!
*
* @brief  ETMͨܣGPIO 
*        
* @param[in]    pETM                  ָETMʱһĻַ.
* @param[in]    u8ETM_Channel         ͨ.
*
* @return none.
*
*********************************************************************************/

void ETM_disblechannel(ETM_Type *pETM, uint8_t u8ETM_Channel)
{    
     uint8_t   i;
     i= u8ETM_Channel;
     pETM->CONTROLS[i].CnSC &= ~ (ETM_CnSC_ELSB_MASK| ETM_CnSC_ELSA_MASK); 
}

/*********************************************************************************//*!
*
* @brief 벶׽ʼ.
*        
* @param[in]    pETM                  ָETMʱһĻַ.
* @param[in]    Channel               ͨ.
* @param[in]    CaptureMode           ѡ׽ʽ:, ½ػ.
*
* @return none.
*
*********************************************************************************/
void ETM_InputCaptureInit(ETM_Type *pETM, uint8_t u8ETM_Channel, uint8_t u8CaptureMode)
{ 
    ASSERT(((ETM0 == pETM) && (u8ETM_Channel < 2))   || 
           ((ETM1 == pETM) && (u8ETM_Channel < 2))   || 
           ((ETM2 == pETM) && (u8ETM_Channel < 6))
           );

    
      /* ѡETMʱ */
		if ((ETM0 == pETM) && (u8ETM_Channel < 2))
    {
        SIM->SCGC |= SIM_SCGC_ETM0_MASK;
        NVIC_EnableIRQ(ETM0_IRQn);
    }
    else if((ETM1 == pETM)  && (u8ETM_Channel < 2))
    {
        SIM->SCGC |= SIM_SCGC_ETM1_MASK;
        NVIC_EnableIRQ(ETM1_IRQn);
    }        
    else 
    {
        SIM->SCGC |= SIM_SCGC_ETM2_MASK;
        NVIC_EnableIRQ(ETM2_IRQn);
    }
    
    pETM->SC  = 0x0;     //رռ 
    pETM->MOD = 0xFFFF;  
    
    if(ETM_INPUTCAPTURE_RISINGEDGE == u8CaptureMode)        //жϣ
    {
        pETM->CONTROLS[u8ETM_Channel].CnSC = ETM_CnSC_CHIE_MASK | ETM_CnSC_ELSA_MASK;
    }
    else if(ETM_INPUTCAPTURE_FALLINGEDGE == u8CaptureMode)  //½
    {
        pETM->CONTROLS[u8ETM_Channel].CnSC = ETM_CnSC_CHIE_MASK | ETM_CnSC_ELSB_MASK;
    }
    else if(ETM_INPUTCAPTURE_BOTHEDGE == u8CaptureMode)     //
    {
        pETM->CONTROLS[u8ETM_Channel].CnSC = ETM_CnSC_CHIE_MASK | ETM_CnSC_ELSA_MASK | ETM_CnSC_ELSB_MASK;       
    }
}

/*********************************************************************************//*!
*
* @brief  ETM˫߲ģʽһĿȻ(ETM2).
*        
* @param[in]    pETM                  ETM2.
* @param[in]    ChannelPair           ƵΪ: 0, 2, 4.
* @param[in]    CaptureMode           ѡڲ׽4׽ʽ5.
* @param[in]    Channel_N_Edge        ƵNؼ⣺ޣ0أ1½أ2˫أ3. 
* @param[in]    Channel_Np1_Edge      ƵN+1ؼ.
*
* @return none.
*
*********************************************************************************/
void ETM_DualEdgeCaptureInit(ETM_Type *pETM, uint8_t u8ChannelPair, uint8_t u8CaptureMode, 
                                 uint8_t u8Channel_N_Edge, uint8_t u8Channel_Np1_Edge)
{ 
    ASSERT((ETM2 == pETM)  && (u8ChannelPair < 6) && !(u8ChannelPair & 1) );
    
    SIM->SCGC |= SIM_SCGC_ETM2_MASK;
    if((0 == u8ChannelPair) || (2== u8ChannelPair))
    {
                                      
    }
       
    pETM->SC    = 0x0;                  /* رռ */ 
    pETM->MOD   = 0xFFFF;
    pETM->MODE |= ETM_MODE_ETMEN_MASK;  /* ETMEN = 1 */  
    
    pETM->COMBINE |=  ((ETM_COMBINE_DECAPEN0_MASK) << (u8ChannelPair * 4)); 
    
    pETM->CONTROLS[u8ChannelPair].CnSC &= ~ETM_CnSC_CHF_MASK;       /* CH(n)F  CH(n+1)F λҪ */
    pETM->CONTROLS[u8ChannelPair + 1].CnSC &= ~ETM_CnSC_CHF_MASK;
    
    if(ETM_INPUTCAPTURE_DUALEDGE_ONESHOT == u8CaptureMode)          /* ģʽ */
    {
        pETM->CONTROLS[u8ChannelPair].CnSC &= ~ETM_CnSC_MSA_MASK;
        pETM->CONTROLS[u8ChannelPair+1].CnSC &= ~ETM_CnSC_MSA_MASK;
    }
    else if(ETM_INPUTCAPTURE_DUALEDGE_CONTINUOUS == u8CaptureMode)  /* ģʽ */
    {
        pETM->CONTROLS[u8ChannelPair].CnSC |= ETM_CnSC_MSA_MASK;
        pETM->CONTROLS[u8ChannelPair+1].CnSC |= ETM_CnSC_MSA_MASK;
    }
    
    pETM->CONTROLS[u8ChannelPair].CnSC |= (u8Channel_N_Edge << 2);   /* ѡ */
    pETM->CONTROLS[u8ChannelPair + 1].CnSC |= (u8Channel_Np1_Edge << 2);   
    
    pETM->COMBINE |=  (ETM_COMBINE_DECAP0_MASK << (u8ChannelPair * 4)); 
}

/*********************************************************************************//*!
*
* @brief Աȳʼ.
*        
* @param[in]    pETM                  ָETMʱһĻַ.
* @param[in]    Channel               ͨͨ.
* @param[in]    CompareMode           ѡģʽת01λ11010.
*
* @return none.
*
*********************************************************************************/
void ETM_OutputCompareInit(ETM_Type *pETM, uint8_t u8ETM_Channel, uint8_t u8CompareMode)
{
    ASSERT(((ETM0 == pETM) && (u8ETM_Channel < 2))   || 
           ((ETM1 == pETM) && (u8ETM_Channel < 2))   || 
           ((ETM2 == pETM) && (u8ETM_Channel < 6))
           );
    
    /* ѡETMģʱ */
	if(ETM0 == pETM)
    {
        SIM->SCGC |= SIM_SCGC_ETM0_MASK;
    }
    else if(ETM1 == pETM)
    {
        SIM->SCGC |= SIM_SCGC_ETM1_MASK;
    }        
    else
    {
        SIM->SCGC |= SIM_SCGC_ETM2_MASK;
    }
    
    pETM->SC  = 0x0;                                                                    //رռ
    pETM->MOD = ETM_MOD_INIT; 
    pETM->CONTROLS[u8ETM_Channel].CnSC = (ETM_CnSC_MSA_MASK | (u8CompareMode << 2));   
    pETM->CONTROLS[u8ETM_Channel].CnV  = ETM_C0V_INIT;
}

/*********************************************************************************//*!
*
* @brief ʵͬETM2.
*        
* @param[in]    pETM                  ETM2.
*
* @return none.
*
*********************************************************************************/
void ETM_SoftwareSync(ETM_Type *pETM)
{
    ASSERT(ETM2 == pETM);

    pETM->SYNCONF   |= ETM_SYNCONF_SYNCMODE_MASK;   
    pETM->SYNC      |= ETM_SYNC_SWSYNC_MASK;
}

/*********************************************************************************//*!
*
* @brief ETMETMx_SYNC ĴѡӲ(ETM2).
*        
* @param[in]    pETM                  ETM2.
* @param[in]    u8TriggerN            ѡӲԴ.
*
* @return none.
*
*********************************************************************************/
void ETM_HardwareSync(ETM_Type *pETM, uint8_t u8TriggerN)
{
    ASSERT(ETM2 == pETM);
    
    pETM->SYNCONF   |= ETM_SYNCONF_SYNCMODE_MASK;  
    
    switch(u8TriggerN)
    {
        case ETM_SYNC_TRIGGER_TRIGGER2: 
                pETM->SYNC |= ETM_SYNC_TRIG2_MASK;
                break;  
        case ETM_SYNC_TRIGGER_TRIGGER1: 
                pETM->SYNC |= ETM_SYNC_TRIG1_MASK;
                break;     /* ҪETM0CH0 */
        case ETM_SYNC_TRIGGER_TRIGGER0:
                pETM->SYNC |= ETM_SYNC_TRIG0_MASK; 
                break;     /* ҪACMP0 */
        default: 
                break;
    }
}

/*********************************************************************************//*!
*
* @brief ͨETM֤Ӳͬж(ETM2).
*        
* @param[in]    pETM               ETM2.
* @param[in]    u8TriggerMask      ӲԴ־.TRIG0~TREG2.(x000xxxx~x111xxxx)
*
* @return none.
*
*********************************************************************************/
void ETM_HardwareSyncCombine(ETM_Type *pETM, uint8_t u8TriggerMask)
{
    ASSERT(ETM2 == pETM);
    
    pETM->SYNCONF   |= ETM_SYNCONF_SYNCMODE_MASK;   
    pETM->SYNC      &= 0x8F;
    pETM->SYNC      |= (u8TriggerMask & 0x70);
}

/*********************************************************************************//*!
*
* @brief Ӳ2ETM2PWMͬ(ETM2)
*        
* @param[in]    pETM              ETM2.
*
* @return none.
*
*********************************************************************************/
void ETM_GenerateTrig2(ETM_Type *pETM)
{
    ASSERT(ETM2 == pETM);
    
    if(pETM->SYNC & ETM_SYNC_TRIG2_MASK)
    {
#if defined(CPU_NV32)
        SIM->SOPT  |= SIM_SOPT_ETMSYNC_MASK;
#endif
    }
}


/*********************************************************************************//*!
*
* @brief ETMʱãETM2.
*        
* @param[in]    pETM                  ETM2.
* @param[in]    PrescalerValue        ʱӷƵֵ, 0 to 3.
* @param[in]    DeadETMeValue         ʱֵ, 0 to 63.
*
* @return none.
*
*********************************************************************************/
void ETM_PWMDeadETMeSet(ETM_Type *pETM, uint8_t u8PrescalerValue, uint8_t u8DeadETMeValue)
{
    ASSERT(ETM2 == pETM);
    
    pETM->COMBINE |= 0x101010;              /* ʹʱ */

    if(!(pETM->MODE & ETM_MODE_WPDIS_MASK)) /* жǷʹд */
    {
        pETM->MODE |= ETM_MODE_WPDIS_MASK;  /* ֹд */
        pETM->DEADETME = (ETM_DEADETME_DTVAL(u8DeadETMeValue & 0x3F) | ETM_DEADETME_DTPS(u8PrescalerValue & 0x3));
        pETM->MODE &= ~ETM_MODE_WPDIS_MASK; /* ʹд */       
    }
    else 
    {
        /* д */
        pETM->DEADETME = (ETM_DEADETME_DTVAL(u8DeadETMeValue & 0x3F) | ETM_DEADETME_DTPS(u8PrescalerValue & 0x3));
    }
    pETM->SYNC |= ETM_SYNC_SWSYNC_MASK;     /* ͬ */
}    

/*********************************************************************************//*!
*
* @brief ΣETM2.
*        
* @param[in]    pETM                  ETM2.
* @param[in]    Channel               Ҫεͨ.
*
* @return none.
*
*********************************************************************************/
void ETM_OutputMaskSet(ETM_Type *pETM, uint8_t u8ETM_Channel)
{
    ASSERT((ETM2 == pETM) && (u8ETM_Channel < 6));

    pETM->OUTMASK |= (1 << u8ETM_Channel);
    
    if(pETM->SYNC & ETM_SYNC_SYNCHOM_MASK)              /* ͨPWMͬ */
    {
        pETM->SYNCONF |= ETM_SYNCONF_SYNCMODE_MASK;   
        if(pETM->SYNCONF & ETM_SYNCONF_SWOM_MASK)       /*  */
        {
            pETM->SYNC |= ETM_SYNC_SWSYNC_MASK;
        }
        else if(pETM->SYNCONF & ETM_SYNCONF_HWOM_MASK)  /* Ӳ */
        {
            pETM->SYNC |= ETM_SYNC_TRIG2_MASK;
            
#if defined(CPU_NV32)
            SIM->SOPT  |= SIM_SOPT_ETMSYNC_MASK;         /* ʹӲͬ */ 
#endif
        }
        else
        {
        }
    }
    else  /* ͬ, ϵͳʱӵض  */
    {
    }
}

/*********************************************************************************//*!
*
* @brief SWOCTRLĴͬǷ(ETM2).
*        
* @param[in]    pETM                  ETM2.
* @param[in]    Channel               PWMͨѡ.
* @param[in]    ChannelValue          01,0;1.
*
* @return none.
*
*********************************************************************************/
void ETM_SWOutputControlSet(ETM_Type *pETM, uint8_t u8ETM_Channel, uint8_t u8ChannelValue)
{
    ASSERT((ETM2 == pETM) && (u8ETM_Channel < 6));
    
    if(ETM_SWOCTRL_HIGH == u8ChannelValue)
    {
        pETM->SWOCTRL |= (0x0101 << u8ETM_Channel);
    }
    else if(ETM_SWOCTRL_LOW == u8ChannelValue)
    {
        pETM->SWOCTRL |= (1 << u8ETM_Channel);
        pETM->SWOCTRL &= ~(0x100 << u8ETM_Channel);
    }
    if(pETM->SYNCONF & ETM_SYNCONF_SWOC_MASK)               
    {
        pETM->SYNCONF |= ETM_SYNCONF_SYNCMODE_MASK;        
        if(pETM->SYNCONF & ETM_SYNCONF_SWSOC_MASK)        
        {
            pETM->SYNC |= ETM_SYNC_SWSYNC_MASK;            
        }
        else if(pETM->SYNCONF & ETM_SYNCONF_HWSOC_MASK)     
        {
            pETM->SYNC |= ETM_SYNC_TRIG2_MASK;

#if defined(CPU_NV32)
            SIM->SOPT  |= SIM_SOPT_ETMSYNC_MASK;          
#endif
        }
    }
    else 
    {
    }
}

/*********************************************************************************//*!
*
* @brief ͨ(ETM2).
*        
* @param[in]    pETM                  ETM2.
* @param[in]    Channel               PWMͨѡ.
* @param[in]    ActiveValue           Եѡ0Ϊߵƽ1Ϊ͵ƽ.
*
* @return none.
*
*********************************************************************************/
void ETM_PolaritySet(ETM_Type *pETM, uint8_t u8ETM_Channel, uint8_t u8ActiveValue)
{
    ASSERT((ETM2 == pETM) && (u8ETM_Channel < 6));
    
    if(ETM_POLARITY_HIGHACTIVE == u8ActiveValue)
    {
        pETM->POL &=  ~(1 << u8ETM_Channel);
    }
    else if(ETM_POLARITY_LOWACTIVE == u8ActiveValue)
    {
        pETM->POL |=  (1 << u8ETM_Channel);
    }
}

/*********************************************************************************//*!
*
* @brief ETMģdebugģʽµΪ(ETM2).
*        
* @param[in]    pETM             ETM2.
* @param[in]    u8DebugMode      debug ģʽ00-11֮ѡ.
*
* @return none.
*
*********************************************************************************/
void ETM_SetDebugModeBehavior(ETM_Type *pETM, uint8_t u8DebugMode)
{
    ASSERT((ETM2 == pETM));
    pETM->CONF &= ~ETM_CONF_BDMMODE_MASK;
    pETM->CONF |= ETM_CONF_BDMMODE(u8DebugMode);
}

/*********************************************************************************//*!
*
* @brief ETMTOFƵʴС(ETM2).
*        
* @param[in]    pETM             ETM2.
* @param[in]    u8TOFNUM         TOFƵС031֮.
*
* @return none.
*
*********************************************************************************/
void ETM_SetTOFFrequency(ETM_Type *pETM, uint8_t u8TOFNUM)
{
    ASSERT((ETM2 == pETM));
    pETM->CONF &= ~ETM_CONF_NUMTOF_MASK;
    pETM->CONF |= ETM_CONF_NUMTOF(u8TOFNUM);
}

/*********************************************************************************//*!
*
* @brief ͨCHnͨCHn+1(ETM2).
*        
* @param[in]    pETM                  ETM2.
* @param[in]    ChannelPair           ҪͨţnΪ0,1,2.
*    
* @return none.
*
*********************************************************************************/
void ETM_InvertChannel(ETM_Type *pETM, uint8_t u8ChannelPair)
{
    ASSERT((ETM2 == pETM)  && u8ChannelPair <= 2);

    pETM->INVCTRL |= 1<<u8ChannelPair;
    if(pETM->SYNCONF & ETM_SYNCONF_INVC_MASK)       
    {
        pETM->SYNCONF |= ETM_SYNCONF_SYNCMODE_MASK; 
        if(pETM->SYNCONF & ETM_SYNCONF_SWINVC_MASK)
        {
            pETM->SYNC |= ETM_SYNC_SWSYNC_MASK;    
        }
        else if(pETM->SYNCONF & ETM_SYNCONF_HWINVC_MASK)  
        {
            pETM->SYNC |= ETM_SYNC_TRIG2_MASK;

#if defined(CPU_NV32)
            SIM->SOPT  |= SIM_SOPT_ETMSYNC_MASK;           
  
#endif
        }
    }
    else 
    {
    }
}  

/*****************************************************************************//*!
*
* @brief ETMģʼ.
*        
* @param[in]    pETM        ָETMʱһĻַ.
* @param[in]    pConfig     ETMģĽṹ.
*
* @return none.
*
*****************************************************************************/
void ETM_Init(ETM_Type *pETM, ETM_ConfigType *pConfig)
{
    ASSERT((ETM0 == pETM) || (ETM1 == pETM) || (ETM2 == pETM));
    if(ETM0 == pETM)
    {
        SIM->SCGC |= SIM_SCGC_ETM0_MASK;
    }
    else if(ETM1 == pETM)
    {
        SIM->SCGC |= SIM_SCGC_ETM1_MASK;
    }
    else
    {
        SIM->SCGC |= SIM_SCGC_ETM2_MASK;
    }
        
    /*رռ*/
    pETM->SC = 0; 
		pETM->MODE = pConfig->mode;       
		pETM->MOD = pConfig->modulo;
		pETM->CNT = pConfig->cnt;
        
    if( pETM->MODE & ETM_MODE_ETMEN_MASK  ) 
    {
        /*  ETMEN = 1ʱ, мĴд */
        pETM->COMBINE   = pConfig->combine;      
        pETM->CNTIN     = pConfig->cntin;      
        pETM->SYNC      = pConfig->sync;      
        pETM->OUTINIT   = pConfig->outinit;      
        pETM->OUTMASK   = pConfig->outmask;      
        pETM->DEADETME  = pConfig->deadETMe;      
        pETM->EXTTRIG   = pConfig->exttrig;      
        pETM->POL       = pConfig->pol;      
        pETM->FMS       = pConfig->fms;      
        pETM->FILTER    = pConfig->filter;      
        pETM->FLTCTRL   = pConfig->fltctrl;    
        pETM->FLTPOL    = pConfig->fltpol;      
        pETM->CONF      = pConfig->conf;      
        pETM->SYNCONF   = pConfig->synconf;      
        pETM->SWOCTRL   = pConfig->swoctrl;      
        pETM->PWMLOAD   = pConfig->pwmload;      
    }
    /* д״̬ƼĴʹʱ*/
    pETM->SC = pConfig->sc;
}


/*****************************************************************************//*!
*
* @brief  λETMģ.
*        
* @param[in]    pETM          ָETMʱһĻַ.
*
* @return none.
*
*****************************************************************************/
void ETM_DeInit(ETM_Type *pETM)
{
    ASSERT((ETM0 == pETM) || (ETM1 == pETM) || (ETM2 == pETM));
    pETM->SC = 0;       
		pETM->MOD = 0;
		pETM->CNT = 0;
    if(ETM2 == pETM) 
    {
          pETM->MODE = 0x4; 
          pETM->COMBINE = 0;      
          pETM->CNTIN = 0;      
          pETM->SYNC = 0;      
          pETM->OUTINIT = 0;      
          pETM->OUTMASK = 0;      
          pETM->DEADETME = 0;      
          pETM->EXTTRIG = 0;      
          pETM->POL = 0;      
          pETM->FMS = 0;      
          pETM->FILTER = 0;      
          pETM->FLTCTRL = 0;  
          pETM->FLTPOL = 0;      
          pETM->CONF = 0;      
          pETM->SYNCONF = 0;      
          pETM->SWOCTRL = 0;      
          pETM->PWMLOAD = 0;      
    }
    /* ֹETMģʱ */
		if (ETM0 == pETM)
    {
        SIM->SCGC &= ~SIM_SCGC_ETM0_MASK;
        NVIC_DisableIRQ(ETM0_IRQn);
    }
    else if(ETM1 == pETM)
    {
        SIM->SCGC &= ~SIM_SCGC_ETM1_MASK;
        NVIC_DisableIRQ(ETM1_IRQn);
    } 
    else if (ETM2 == pETM)
    {
        SIM->SCGC &= ~SIM_SCGC_ETM2_MASK;
        NVIC_DisableIRQ(ETM2_IRQn);
    }
}
    
/*****************************************************************************//*!
*
* @brief ETMͨ, ͨ״̬ƼĴCnSCֵͨĴCnV.
*        
* @param[in]    pETM               ָETMʱһĻַ.
* @param[in]    ETM_Channel        ETMͨ.
* @param[in]    pTETMCH_Params     ETMͨĽṹ.
*
* @return none.
*
*****************************************************************************/
void ETM_ChannelInit(ETM_Type *pETM, uint8_t u8ETM_Channel, ETM_ChParamsType *pTETMCH_Params)
{
    ASSERT((ETM0 == pETM) || (ETM1 == pETM) || (ETM2 == pETM)); //Լͨȷ
    
		if (ETM0 == pETM)
    {
        ASSERT(u8ETM_Channel < 2);
        SIM->SCGC |= SIM_SCGC_ETM0_MASK;
    }
    else if(ETM1 == pETM)
    {
        ASSERT(u8ETM_Channel < 2);
        SIM->SCGC |= SIM_SCGC_ETM1_MASK;
    }        
    else
    {
        ASSERT(u8ETM_Channel < 6);
        SIM->SCGC |= SIM_SCGC_ETM2_MASK;
    }
    
    pETM->CONTROLS[u8ETM_Channel].CnSC = pTETMCH_Params->u8CnSC;
    pETM->CONTROLS[u8ETM_Channel].CnV = pTETMCH_Params->u16CnV; 
    
    return;
}

/*****************************************************************************//*!
*
* @brief üģʽռձ(ETM2).
*
* @param[in]    pETM            ETM2.
* @param[in]    ETM_Channel     ͨ135.
* @param[in]    dutyCycle       ռձȣDutyCycleΪ10,ôռձȾΪ10%.
*
* @return none.
*
*****************************************************************************/
void  ETM_SetDutyCycleCombine(ETM_Type *pETM, uint8_t u8ETM_Channel, uint8_t u8DutyCycle)
{
    uint16_t   cnv = pETM->CONTROLS[u8ETM_Channel-1].CnV;
    uint16_t   modulo = pETM->MOD; 
    
    ASSERT((1 == u8ETM_Channel) || (3 == u8ETM_Channel) || (5 == u8ETM_Channel));
    
    cnv += (u8DutyCycle * (modulo+1))  / 100;
    if(cnv > modulo)
    {
        cnv = modulo - 1;
    }
    pETM->CONTROLS[u8ETM_Channel].CnV = cnv ;    
    
    pETM->PWMLOAD |= ETM_PWMLOAD_LDOK_MASK | (1<<u8ETM_Channel);     
}

/*****************************************************************************//*!
*
* @brief üĴ ETMx_SYNCONFλλ,ĿǷӲHWǷSW(ETM2)
*
* @param[in]    pETM             ETM2.
* @param[in]    u32ConfigValue   SYNCONFĴ.
*
* @return none.
*
*****************************************************************************/
void  ETM_SyncConfigActivate(ETM_Type *pETM, uint32_t u32ConfigValue)
{
    ASSERT((ETM2 == pETM));
    pETM->SYNCONF |= u32ConfigValue;   
}

/*****************************************************************************//*!
*
* @brief üĴ ETMx_SYNCONFλ,ĿǷӲHWǷSW(ETM2)
*
* @param[in]    pETM             ETM2.
* @param[in]    u32ConfigValue   SYNCONFĴ.
*
* @return none.
*
*****************************************************************************/
void  ETM_SyncConfigDeactivate(ETM_Type *pETM, uint32_t u32ConfigValue)
{
    ASSERT((ETM2 == pETM));
    pETM->SYNCONF &= ~u32ConfigValue;   
}

/*****************************************************************************//*!
*
* @brief ûص.
*
* @param[in]    pETM            ָETMʱһĻַ.
* @param[in]    pfnCallback     صַ.
*
* @return none.
*
*****************************************************************************/
void  ETM_SetCallback(ETM_Type *pETM, ETM_CallbackPtr pfnCallback)
{
   ETM_Callback[((uint32_t)pETM - (uint32_t)ETM0_BASE)>>12] = pfnCallback;
}



/*****************************************************************************//*!
*
* @brief ETM0ͨжϷ.
*        
* @param none
*
* @return none 
*
*****************************************************************************/
void ETM0_Isr(void)
{
    if(ETM_Callback[0])
    {
        ETM_Callback[0]();
    }
}

/*****************************************************************************//*!
*
* @brief ETM1ͨжϷ.
*        
* @param none
*
* @return none 
*
*****************************************************************************/
void ETM1_Isr(void)
{
    if(ETM_Callback[1])
    {
        ETM_Callback[1]();
    }
}

/*****************************************************************************//*!
*
* @brief ETM2ͨжϷ.
*        
* @param none
*
* @return none 
*
*****************************************************************************/
void ETM2_Isr(void)
{
    if(ETM_Callback[2])
    {
        ETM_Callback[2]();
    }
}



