/******************************************************************************
*
* @brief  PIT ͷļ.  
*
******************************************************************************/
#ifndef PIT_H_
#define PIT_H_
#include"common.h"
#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************
* PIT ͨб
*
*//*!
*******************************************************************************/
enum
{
    PIT_CHANNEL0 = 0,       /*!< PIT ͨ 0 */
    PIT_CHANNEL1            /*!< PIT ͨ 1 */
};

/*!                                                                           */


/*!
 * @brief PIT ص.
 *
 */

typedef void (*PIT_CallbackType)(void);            





/* PIT ýṹ
 */  
/*!
 * @brief PIT ò.
 *
 */
typedef struct
{   
    uint8_t bFreeze         : 1;    /*!< 1: ڵģʽʱ, 0: ڵģʽʱȻ */
    uint8_t bModuleDis      : 1;    /*!< 1: PITģ, 0: ʹPITģ */    
    uint8_t bReserved0      : 1;    /*!<  */ 
    uint8_t bReserved1      : 5;    /*!<  */ 
    uint8_t bETMerEn        : 1;    /*!< 1: ʹPITͨ, 0: ֹPITͨ */ 
    uint8_t bInterruptEn    : 1;    /*!< 1: ʹPITͨж, 0: ֹPITͨж */ 
    uint8_t bChainMode      : 1;    /*!< 1: ʹģʽ, 0: ֹģʽ */ 
    uint8_t bReserved2      : 5;    /*!<  */ 
    uint8_t bFlag           : 1;    /*!< 1: PITжϱ־λλ,д10, 0: PITжϱ־λûλ */
    uint8_t bReserved3      : 7;    /*!<  */   
    uint32_t u32LoadValue      ;    /*!< 32λͨģֵ */  
} PIT_ConfigType, *PIT_ConfigPtr; 


/******************************************************************************
******************************************************************************/

/*!
 * 
 */
/*****************************************************************************//*!
*
* @brief ʹPITģ.
*        
* @param none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_Enable(void)
{

    PIT->MCR &= ~PIT_MCR_MDIS_MASK; 
    
}

/*****************************************************************************//*!
*
* @brief PITģ.
*        
* @param none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_Disable(void)
{

    PIT->MCR |= PIT_MCR_MDIS_MASK; 
}


/*****************************************************************************//*!
*
* @brief PITڵģʽ½ֹ.
*        
* @param none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_SetDebugFreeze(void)
{

    PIT->MCR |= PIT_MCR_FRZ_MASK;
}


/*****************************************************************************//*!
*
* @brief PITڵģʽ¼.
*        
* @param none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_SetDebugOn(void)
{

    PIT->MCR &= ~PIT_MCR_FRZ_MASK;
}


/*****************************************************************************//*!
*
* @brief PITʱͨʹ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelEnable(uint8_t u8Channel)

{

    PIT->CHANNEL[u8Channel].TCTRL |= PIT_TCTRL_TEN_MASK; 
}


/*****************************************************************************//*!
*
* @brief PITʱͨ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelDisable(uint8_t u8Channel)
{

    PIT->CHANNEL[u8Channel].TCTRL &= ~PIT_TCTRL_TEN_MASK; 
}


/*****************************************************************************//*!
*
* @brief ʹPITʱͨж.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelEnableInt(uint8_t u8Channel)

{

    PIT->CHANNEL[u8Channel].TCTRL |= PIT_TCTRL_TIE_MASK; 
}


/*****************************************************************************//*!
*
* @brief PITʱͨж.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelDisableInt(uint8_t u8Channel)

{

    PIT->CHANNEL[u8Channel].TCTRL &= ~PIT_TCTRL_TIE_MASK; 
}


/*****************************************************************************//*!
*
* @brief ʹPITʱͨģʽ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelEnableChain(uint8_t u8Channel)
{
    PIT->CHANNEL[u8Channel].TCTRL |= PIT_TCTRL_CHN_MASK;
}


/*****************************************************************************//*!
*
* @brief PITʱͨģʽ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelDisableChain(uint8_t u8Channel)

{
    PIT->CHANNEL[u8Channel].TCTRL &= ~PIT_TCTRL_CHN_MASK;
}


/*****************************************************************************//*!
*
* @brief ȡPITͨжϱ־λ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return PITͨжϱ־λ.
*
*****************************************************************************/
__STATIC_INLINE uint8_t PIT_ChannelGetFlags(uint8_t u8Channel)

{
    uint8_t bflag;  
    
    bflag = (PIT->CHANNEL[u8Channel].TFLG & PIT_TFLG_TIF_MASK);    
    
    return bflag;
    
}


/*****************************************************************************//*!
*
* @brief PITͨжϱ־λ.
*        
* @param[in]   u8Channel   ͨ.
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void PIT_ChannelClrFlags(uint8_t u8Channel)
{
    PIT->CHANNEL[u8Channel].TFLG |= PIT_TFLG_TIF_MASK;       
}


/******************************************************************************
******************************************************************************/
void PIT_Init(uint8_t u8Channel_No, PIT_ConfigType *pConfig);
void PIT_SetLoadVal(uint8_t u8Channel, uint32_t u32loadvalue);
void PIT_SetCallback(uint8_t u8Channel_No, PIT_CallbackType pfnCallback);
void PIT_DeInit(void);
                                          
#ifdef __cplusplus
}
#endif
#endif /* PIT_H_ */
