/******************************************************************************
*
* @brief  RTC ͷļ.  
*
******************************************************************************/
#ifndef RTC_H_
#define RTC_H_
#ifdef __cplusplus
extern "C" {
#endif
	
#include "common.h"
/******************************************************************************
* RTCλ
*
*//*! 
* @{
*******************************************************************************/

#define RTC_OUTPUT_ENABLE           1	/*!< ʹRTC  */ 
#define RTC_INTERRUPT_ENABLE        1	/*!< ʹRTCж  */ 
#define RTC_CLKSRC_EXTERNAL         0	/*!< ѡⲿʱΪRTCʱԴ  */
#define RTC_CLKSRC_1KHZ             1	/*!< ѡLPOʱΪRTCʱԴ  */
#define RTC_CLKSRC_IREF             2	/*!< ѡڲοʱICSIRCLKΪRTCʱԴ  */
#define RTC_CLKSRC_BUS              3	/*!< ѡʱΪRTCʱԴ  */
#define RTC_CLK_PRESCALER_128       1	/*!< RTCLKSλѡ1128Ƶ */
#define RTC_CLK_PRESCALER_256       2	/*!< RTCLKSλѡ2256Ƶ */
#define RTC_CLK_PRESCALER_512       3	/*!< RTCLKSλѡ4512Ƶ */
#define RTC_CLK_PRESCALER_1024      4	/*!< RTCLKSλѡ81024Ƶ */
#define RTC_CLK_PRESCALER_2048      5	/*!< RTCLKSλѡ162048Ƶ */
#define RTC_CLK_PRESCALER_100       6	/*!< RTCLKSλѡ32100Ƶ */
#define RTC_CLK_PRESCALER_1000      7	/*!< RTCLKSλѡ641000Ƶ */


/*! @}                                                                        */


/*!
 * @brief RTC ص.
 *
 */

typedef void (*RTC_CallbackType)(void);



/* RTC ýṹ
 */  
/*!
 * @brief RTC ò.
 *
 */
typedef struct
{   
    uint16_t bReserved                  : 4;    /*!<  */     
    uint16_t bRTCOut                    : 1;    /*!< 1: ʹRTC, 0: ֹRTC */
    uint16_t bReserved1                 : 1;    /*!<  */ 
    uint16_t bInterruptEn               : 1;    /*!< 1: ʹRTCж, 0: RTC ֹRTCж */
    uint16_t bFlag                      : 1;    /*!< 1: RTCʵʱжϱ־ */   
    uint16_t bClockPresaler             : 3;    /*!< 3: RTCƵϵѡ */    
    uint16_t bReserved2                 : 3;    /*!< */ 
    uint16_t bClockSource               : 2;    /*!< 2:RTCʱԴѡ */
    uint16_t u16ModuloValue                ;    /*!< 16λRTCģֵ */
} RTC_ConfigType, *RTC_ConfigPtr; 


/******************************************************************************
******************************************************************************/

/*!
 * 
 */
/*****************************************************************************//*!
*
* @brief ʹRTCж.
*        
* @param none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void RTC_EnableInt(void)
{
    RTC->SC |= RTC_SC_RTIE_MASK;
}

/*****************************************************************************//*!
*
* @brief ֹRTCж.
*        
* @param none
*
* @return non
*
*****************************************************************************/
__STATIC_INLINE void RTC_DisableInt(void)
{
    RTC->SC &= ~RTC_SC_RTIE_MASK;
}

/*****************************************************************************//*!
*
* @brief 16λRTCģֵ.
*        
* @param[in]   u16Mod_Value   16λģֵ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void RTC_SetModulo(uint16_t u16Mod_Value)
{
 
    RTC->MOD = u16Mod_Value;
}

/*****************************************************************************//*!
*
* @brief RTCʱԼƵϵ.
*        
* @param[in]   u16Clock_Number   ѡʱԴ
* @param[in]   u16Presalcer      Ƶϵ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void RTC_SetClock(uint16_t u16Clock_Number, uint16_t u16Presalcer)
{
    uint32_t u32rtc_sc;
        
    u32rtc_sc  = RTC->SC; 
    u32rtc_sc &= ~(RTC_SC_RTCLKS_MASK | RTC_SC_RTCPS_MASK);
    u32rtc_sc |= RTC_SC_RTCLKS(u16Clock_Number) | RTC_SC_RTCPS(u16Presalcer); 
    RTC->SC   = u32rtc_sc;
}

/*****************************************************************************//*!
*
* @brief ȡRTCжϱ־λ.
*        
* @param none 
*
* @return RTCжϱ־λ.
*
*****************************************************************************/
__STATIC_INLINE uint8_t RTC_GetFlags(void)
{
  uint8_t bflag;
  
  bflag = RTC->SC & RTC_SC_RTIF_MASK; 
  
  return bflag;  
}


/*****************************************************************************//*!
*
* @brief RTCжϱ־λ.
*        
* @param none 
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void RTC_ClrFlags(void)
{
    RTC->SC |= RTC_SC_RTIF_MASK; 
}


/******************************************************************************
******************************************************************************/


void RTC_Init(RTC_ConfigType *pConfig);
void RTC_SetCallback(RTC_CallbackType pfnCallback);
void RTC_DeInit(void);


#ifdef __cplusplus
}
#endif
#endif /* RTC_H_ */
