/*************************************************************************!     
 *     ۣQQȺ  123763203
 *         www.navota.com
 *
 * @file       sim.c
 * @brief      ϵͳģ飨SIM)
 * @author     Navota
 * @date       2018-3-1
 *************************************************************************/

#include "common.h"
#include "sim.h"


#if defined(CPU_NV32)
/*****************************************************************************//*!
 *
 * @ ʼSIMĴ.
 * 
 * @  pConfig       ָSIMýṹ.  
 *
 * @ ޷
 *
 * @ ο  SIM_ConfigType
 *
 *****************************************************************************/
void SIM_Init(SIM_ConfigType *pConfig)
{
    uint32_t    u32Sopt;
    uint32_t    u32PinSel;
    uint32_t    u32Scgc;
    uint32_t    u32BusDiv;
    /*
     * ʼSIMĴ
     */
    u32Sopt     = 0x0010000E; /*ʹSWDRESETNMI */
    u32PinSel   = 0;
    u32Scgc     = 0x00003000;  /* ʹSWDFLASHģʱ */
    u32BusDiv   = 0;
    u32BusDiv = pConfig->sBits.bBusDiv;    /*ʱӷƵֵ*/ 
    if(pConfig->sBits.bDisableNMI)         /*NMI*/
    {
        u32Sopt &= ~SIM_SOPT_NMIE_MASK;        
    }
    if(pConfig->sBits.bDisableRESET)     	 /*RSTPE*/
    {
        u32Sopt &= ~SIM_SOPT_RSTPE_MASK;        
    }   
    if(pConfig->sBits.bDisableSWD)     		 /*SWDE*/
    {
        u32Sopt &= ~SIM_SOPT_SWDE_MASK;        
    } 
    if(pConfig->sBits.bEnableCLKOUT)  		 /*ʹʱ*/
    {
        u32Sopt |= SIM_SOPT_CLKOE_MASK;        
    } 
    if(pConfig->sBits.bETMSYNC)            /*ETM2ͬѡ*/
    {
        u32Sopt |= SIM_SOPT_ETMSYNC_MASK;  /*ETM2ģPWMͬ*/   
    }  
    if(pConfig->sBits.bRXDCE)       			 /*UAT0_RX׽ѡ*/
    {
        u32Sopt |= SIM_SOPT_RXDCE_MASK;    /*UAT0_RXźŽӵUART0ģETM0ͨ1*/       
    }
    if(pConfig->sBits.bTXDME)   					 /*URAT0_TX׽ѡ*/
    {
        u32Sopt |= SIM_SOPT_TXDME_MASK;  	 /*URAT0_TXӳ䵽ǰETM0ͨ*/     
    }
    if(pConfig->sBits.bACIC)             	 /*ģȽ벶ʹ*/
    {
        u32Sopt |= SIM_SOPT_ACIC_MASK;     /* ACMP0ӵETM1ͨ0*/
    }
        if(pConfig->sBits.bRTCC)
    {
        u32Sopt |= SIM_SOPT_RTCC_MASK;     /*RTCӵETM1ͨ*/    
    }
        if(pConfig->sBits.bRXDFE)          /*URT0 RxD˲ѡ*/ 
    {
        u32Sopt |= SIM_SOPT_RXDFE_MASK;    /*RXD0źACMP0˲ȻעUART0*/   
    }
    u32Sopt |= ((pConfig->u8BusRef & 0x07) << 16);     /*ʱ128Ƶ*/  
    u32Sopt |= ((pConfig->u8Delay) << 24);             /*ôETM2ʼ/ƥ䵽ADCתʱʱ*/
    u32Sopt |= ((pConfig->sBits.u8ADHWT & 0x03) << 8); /*ѡETM2ƥΪADCתӲԴ*/
    u32PinSel = pConfig->u32PinSel;
    u32Scgc = pConfig->u32SCGC;   
    
   /*дݵSIMģĴ */
    SIM->SOPT = u32Sopt;
    SIM->PINSEL = u32PinSel;
    SIM->SCGC = u32Scgc; 
    SIM->BUSDIV = u32BusDiv;
}
#endif

/****************************************************************************//*!
 *
 * @ SIMʱѡͨƼĴʹܻ߽ſʱ
 * 
 * @   u32PeripheralMask    ʱ
 * @   u8GateOn             1:, 0:ر.  
 *
 * @ ޷
 *
   *****************************************************************************/

void SIM_SetClockGating(uint32_t u32PeripheralMask, uint8_t u8GateOn)
{
    uint32_t    u32Scgc;
	
    u32Scgc     = SIM->SCGC;
    
    if(u8GateOn)
    {
        u32Scgc |= u32PeripheralMask;
    }
    else
    {
        u32Scgc &= ~u32PeripheralMask;        
    }

    SIM->SCGC = u32Scgc;
}

/*****************************************************************************//*!
 *
 * @ ȡӦ״̬־λ.
 * 
 * @   u32StatusMask    ָʾҪȡ״̬
 *
 * @ ״̬.
 *
 *****************************************************************************/

uint32_t SIM_GetStatus(uint32_t u32StatusMask)
{
    uint32_t    u32Status;

    u32Status = SIM->SRSID & u32StatusMask;  //ȡ״̬־λ
	
    return (u32Status);
}

/*****************************************************************************//*!
 *
 * @ ӦIDĴ.
 *
 * @   u8ID    ID. 
 *
 * @  ID
 *
 * ο IDType
 *
 *****************************************************************************/
uint8_t SIM_ReadID(IDType sID)
{
    uint32_t    u32ID;
    uint8_t u8IDOffset[4] = 
    { 
        28, 24, 20,16
    };  
    u32ID = (SIM->SRSID >> u8IDOffset[sID]) & 0x0F;   //ȡID
    return (u32ID);
}

