/******************************************************************************
*
* @brief  SIM ͷļ.  
*
******************************************************************************/
#ifndef SIM_H_
#define SIM_H_

typedef enum {
    ID_TYPE_FAMID,                  /*!< NV32F100xϵ   ID */
    ID_TYPE_SUBFAMID,               /*!< NV32F100xϵ ID */ 
    ID_TYPE_REVID,                  /*!< 汾 ID */
    ID_TYPE_PINID                   /*!<  ID */
} IDType;
                                                    				

#if defined(CPU_NV32)
typedef struct{
    struct{
        uint32_t bEnableCLKOUT  : 1;        /*!< 1: ʹ , 0:  */
        uint32_t bTXDME         : 1;        /*!< 1: ʹ TXDME, 0:  */
        uint32_t bETMSYNC       : 1;        /*!< 1: ʹ ETM SYNC, 0: δκͬ */
        uint32_t bRXDFE         : 1;        /*!< 1: ʹ RXD ˲, 0: ˲ */
        uint32_t bRXDCE         : 1;        /*!< 1: ʹ RXD ׽, 0: ޲׽ */
        uint32_t bACIC          : 1;        /*!< 1: ACMP0ͨӵETM1ͨ0, 0:  */
        uint32_t bRTCC          : 1;        /*!< 1: RTCӵETM1ͨ1, 0:  */
        uint32_t u8ADHWT        : 2;        /*!<    ѡADCתӲԴ */
        uint32_t bDisableSWD    : 1;        /*!< 1: SWD, 0: ʹ */
        uint32_t bDisableRESET  : 1;        /*!< 1: øλ, 0: ʹ */
        uint32_t bDisableNMI    : 1;        /*!< 1: NMIж, 0:ʹ */
        uint32_t bBusDiv        : 1;        /*!<    ߷Ƶϵ */
    } sBits;
    uint8_t     u8Delay;                		/*!< ETMADCתʱֵ */
    uint8_t     u8BusRef;               		/*!< ߲ο */
    uint32_t    u32PinSel;              		/*!< ѡĴֵ*/
    uint32_t    u32SCGC;                		/*!< ʱѡͨĴֵ */   
} SIM_ConfigType, *SIM_ConfigPtr; /*!< SIMģýṹ */
#endif
                                                 				
  
#if defined(CPU_NV32)
/*****************************************************************************//*!
*
* @brief ETM2ADCתʱʱ
*        
* @param[in]   u8Delay     ʱʱģֵοʱӲʱӷƵ
*
* @return none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/
__STATIC_INLINE void SIM_DelayETM2Trig2ADC(uint8_t u8Delay)
{
    SIM->SOPT = (SIM->SOPT & ~(SIM_SOPT_DELAY_MASK)) | SIM_SOPT_DELAY(u8Delay);    
}
/*****************************************************************************//*!
*
* @brief ʹʱPH2
*
* @param   none
*
* @return none 
*
* @ ο  SIM_DisableClockOutput
*****************************************************************************/
__STATIC_INLINE void SIM_EnableClockOutput(void)
{
    SIM->SOPT |= (SIM_SOPT_CLKOE_MASK);    
}

/*****************************************************************************//*!
*
* @brief ʱPH2
*        
* @param   none
*
* @return none
*
* @ο  SIM_EnableClockOutput
*****************************************************************************/
__STATIC_INLINE void SIM_DisableClockOutput(void)
{
    SIM->SOPT &= ~(SIM_SOPT_CLKOE_MASK);    
}
/*****************************************************************************//*!
*
* @brief ʱƵ. 
*        
* @param[in]  u8Divide     Ƶϵ (3-bits)
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_SetClockOutputDivide(uint8_t u8Divide)
{
    SIM->SOPT = (SIM->SOPT & ~(SIM_SOPT_BUSREF_MASK)) | SIM_SOPT_BUSREF(u8Divide & 0x07);    
}
/*****************************************************************************//*!
*
* @brief UART0_RXźӵUART0ģETM0ͨ1
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_EnableUART0RXDConnectETMOCH1(void)
{
    SIM->SOPT |= (SIM_SOPT_RXDCE_MASK);    
}
/*****************************************************************************//*!
*
* @brief  UART0_TXӳ䵽ǰETM0ͨ0
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_EnableUART0Modulation(void)
{
    SIM->SOPT |= (SIM_SOPT_TXDME_MASK);    
}

/*****************************************************************************//*!
*
* @brief  UART0_TXֱӵ
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_DisableUART0Modulation(void)
{
    SIM->SOPT &= ~(SIM_SOPT_TXDME_MASK);    
}
/*****************************************************************************//*!
*
* @brief ETM2ģPWMͬ
*        
* @param  none       
*
* @return none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/
__STATIC_INLINE void SIM_GenerateSoftwareTrig2ETM2(void)
{
    SIM->SOPT |= (SIM_SOPT_ETMSYNC_MASK);    
}
/*****************************************************************************//*!
*
* @brief ETM2_CH3ͨӳ䵽PD1  
*        
* @param   none
*
* @return none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM2CH3Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM2PS3_MASK;    
}

/*****************************************************************************//*!
*
* @brief  ETM2_CH2ͨӳ䵽PD0
*        
* @param   none
*
* @return  none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM2CH2Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM2PS2_MASK;    
}
/*****************************************************************************//*!
*
* @brief  ETM0_CH1ͨӳ䵽PB3  
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM0CH1Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM0PS1_MASK;    
}
/*****************************************************************************//*!
*
* @brief   ETM0_CH0ͨӳ䵽PB2 
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM0CH0Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM0PS0_MASK;    
}
/*****************************************************************************//*!
*
* @brief  UART0_RXUART0_TXӳ䵽PA2PA3 
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapUART0Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_UART0PS_MASK;    
}

/*****************************************************************************//*!
*
* @brief SPI0_SCK SPI0_MOSI SPI0_MISOSPI0_PCSӳ䵽PE0PE1PE2PE3 
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapSPI0Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_SPI0PS_MASK;    
}

/*****************************************************************************//*!
*
* @brief  I2C0_SCLI2C_SDAֱӳ䵽PB7PB6
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapI2CPin(void)
{
    SIM->PINSEL |= SIM_PINSEL_IICPS_MASK;    
}
/*****************************************************************************//*!
*
* @brief RXD0źACPM0˲ȻעUART0 
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_EnableUART0Filter(void)
{
    SIM->SOPT |= (SIM_SOPT_RXDFE_MASK);    
}
/******************************************************************************!
*
* @brief RXD0źֱӵUARTOģ
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_DisableUART0Filter(void)
{
    SIM->SOPT &= ~(SIM_SOPT_RXDFE_MASK);    
}
/*****************************************************************************//*!
*
* @brief ѡRTCΪADCӲԴ
*        
* @param  none        
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_TriggerADCByRTC(void)
{
    SIM->SOPT &= ~(SIM_SOPT_ADHWT_MASK);    
}
/*****************************************************************************//*!
*
* @brief ѡPITΪADCӲԴ 
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_TriggerADCByPIT(void)
{
    SIM->SOPT = (SIM->SOPT & ~(SIM_SOPT_ADHWT_MASK)) | SIM_SOPT_ADHWT(1);    
}
/*****************************************************************************//*!
*
* @brief ETM2ʼΪADCӲԴ.ETM2ʼ󾭹һʱʱADCת
*        
* @param  none      
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_TriggerADCByETM2Init(void)
{
    SIM->SOPT = (SIM->SOPT & ~(SIM_SOPT_ADHWT_MASK)) | SIM_SOPT_ADHWT(2);    
}

/*****************************************************************************//*!
*
* @brief ETM2ƥΪADCӲԴETM2ƥ󾭹һʱʱADCת
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_TriggerADCByETM2Match(void)
{
    SIM->SOPT = (SIM->SOPT & ~(SIM_SOPT_ADHWT_MASK)) | SIM_SOPT_ADHWT(3);    
}
/*****************************************************************************//*!
*
* @brief RTCӵETM1ͨ1
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_EnableRTCCapture(void)
{
    SIM->SOPT |= (SIM_SOPT_RTCC_MASK);    
}
/*****************************************************************************//*!
*
* @brief RTCδӵETM1ͨ1
*        
* @param  none       
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_DisableRTCCapture(void)
{
    SIM->SOPT &= ~(SIM_SOPT_RTCC_MASK);    
}
/*****************************************************************************//*!
*
* @brief ACMP0ӵETM1ͨ0
*        
* @param  none      
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_EnableACMP0InputCapture(void)
{
    SIM->SOPT |= (SIM_SOPT_ACIC_MASK);    
}
/*****************************************************************************//*!
*
* @brief ACMP0δӵETM1ͨ0 
*        
* @param  none      
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_DisableACMP0InputCapture(void)
{
    SIM->SOPT &= ~(SIM_SOPT_ACIC_MASK);    
}
/*****************************************************************************//*!
*
* @brief RTC0ӳ䵽PC5
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapRTCPin(void)
{
    SIM->PINSEL |= SIM_PINSEL_RTCPS_MASK;    
}
/*****************************************************************************//*!
*
* @brief ʱƵ
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_SetBusDivide(uint8_t u8Divide)
{
    SIM->BUSDIV = u8Divide;    
}
/*****************************************************************************//*!
*
* @brief ETM2_CH1ͨӳ䵽PH1
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM2CH1Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM2PS1_MASK;    
}

/*****************************************************************************//*!
*
* @brief  ETM2_CH0ͨӳ䵽PH0  
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM2CH0Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM2PS0_MASK;    
}

/*****************************************************************************//*!
*
* @brief  ETM1_CH1ͨӳ䵽PE7
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM1CH1Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM1PS1_MASK;    
}

/*****************************************************************************//*!
*
* @brief  ETM1_CH0ӳ䵽PH2
*        
* @param   none
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void SIM_RemapETM1CH0Pin(void)
{
    SIM->PINSEL |= SIM_PINSEL_ETM1PS0_MASK;    
}

#endif

/****************************************************************************/

void SIM_Init(SIM_ConfigType *pConfig);
void SIM_SetClockGating(uint32_t u32PeripheralMask, uint8_t u8GateOn);
uint32_t SIM_GetStatus(uint32_t u32StatusMask);
uint8_t SIM_ReadID(IDType sID);

#endif 


