/******************************************************************************
*
* @brief  UART ͷļ.  
*
******************************************************************************/
#ifndef _UART_H_
#define _UART_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "common.h"
#include "wdog.h"

#define MAX_UART_NO             3


/*!
* @brief UART .
*
*/ 

typedef struct
{
    uint32_t bEnable      : 1;                /*!< 1: ʹ, 0:  */
    uint32_t resvd        : 31;               /*!< 1: λ */
} UART_SettingType;
/*! @}                                                                        */

 /*!
 * @brief UART ýṹ.
 *
 */   
typedef struct 
{
    UART_SettingType    sSettings;  /*!< UART  */
    uint32_t    				u32SysClkHz;        /*!< ϵͳʱ */
    uint32_t    				u32Baudrate;        /*!< UART  */
} UART_ConfigType;
/*! @}                                                                        */

 /*!
 * @brief UART ýṹ.
 *
 */   
typedef struct
{
    uint32_t    u32SysClkHz;        /*!< ϵͳʱ */
    uint32_t    u32Baudrate;        /*!< UART  */
} UART_ConfigBaudrateType;
/*! @}                                                                        */

/******************************************************************************
*define uartģʽб
*
*//*! @uartģʽб
* @{
******************************************************************************/
typedef enum
{
    UART_Mode8Bit,                  /*!< 8λģʽ */
    UART_Mode9Bit,                  /*!< 9λģʽ */
    UART_ModeEnableLoopback,        /*!< ʹܻģʽ */
    UART_ModeDisableLoopback,       /*!< ûģʽ*/
    UART_ModeEnableSingleWire,      /*!< ʹUARTģʽ */
    UART_ModeDisableSingleWire,     /*!< UARTģʽ */
} UART_ModeType;
/*! @}                                                                        */

/******************************************************************************
*define uartж
*
*//*! @uartжб
* @{
******************************************************************************/

typedef enum
{
    UART_TxBuffEmptyInt,            /*!< ж */
    UART_TxCompleteInt,             /*!< ж */
    UART_RxBuffFullInt,             /*!< ж */

    UART_IdleLineInt,               /*!< ж */

    UART_RxOverrunInt,              /*!< ж */
    UART_NoiseErrorInt,             /*!< ж */
    UART_FramingErrorInt,           /*!< /֡ж */
    UART_ParityErrorInt,            /*!< żУж */
} UART_InterruptType;
/*! @}                                                                        */

/******************************************************************************
*define uart־Ͷ
*
*//*! @uart־Ͷб
* @{
******************************************************************************/
typedef enum
{
    UART_FlagPF = 0,        /*!<  */
    UART_FlagFE,            /*!< ֡־ */
    UART_FlagNF,            /*!< ־ */
    UART_FlagOR,            /*!< չ */
    UART_FlagIDLE,          /*!< ߱־ */
    UART_FlagRDRF,          /*!< ־ */
    UART_FlagTC,            /*!< ɱ־ */
    UART_FlagTDRE,          /*!< ͼĴձ־ */

    UART_FlagRAF,           /*!< Ч־ */
    UART_FlagLBKDE,         /*!< LINʹ */
    UART_FlagBRK13,         /*!< ַ */ 
    UART_FlagRWUID,         /*!< ջѿм */
    UART_FlagRXINV,         /*!< ݷת */
    UART_FlagRev1,          /*!<  */
    UART_FlagRXEDGIF,       /*!< RXDŵЧжϱ־ */
    UART_FlagLBKDIF,        /*!< LINֹжϱ־ */
} UART_FlagType;
/*! @}                                                                        */

/*!
 * @brief UART ص.
 *
 */
typedef void (*UART_CallbackType)(UART_Type *pUART);

/******************************************************************************
******************************************************************************/

/*!
 * 
 */
/******************************************************************************
*******************************************************************************/

/*****************************************************************************//*!
*
* @brief ȡ
*        
* @param[in] pUART        ָUARTһĻַ
*
* @return յַ
*
*****************************************************************************/
__STATIC_INLINE uint8_t UART_ReadDataReg(UART_Type *pUART)
{
    return pUART->D;
}

/*****************************************************************************//*!
*
* @brief дַ
*        
* @param[in] pUART       ָUARTһĻַ
* @param[in] u8Char      Ҫ͵ַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_WriteDataReg(UART_Type *pUART, uint8_t u8Char)
{
    pUART->D = (uint8_t)u8Char;
}

/*****************************************************************************//*!
*
* @brief ݼĴǷ
*
* @param[in] pUART       ָUARTһĻַ
*
* @return 0, ûַ; 0, ַյ
*
*****************************************************************************/
__STATIC_INLINE uint8_t UART_CharPresent(UART_Type *pUART)
{  
    return (pUART->S1 & UART_S1_RDRF_MASK);
}
/*****************************************************************************//*!
*
* @brief ʹܷ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableTx(UART_Type *pUART)
{
    
    pUART->C2 |= UART_C2_TE_MASK;
}
/*****************************************************************************//*!
*
* @brief ÷
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_DisableTx(UART_Type *pUART)
{    
    pUART->C2 &= (~UART_C2_TE_MASK);
}

/*****************************************************************************//*!
*
* @brief ʹܽ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableRx(UART_Type *pUART)
{    
    pUART->C2 |= UART_C2_RE_MASK;
}

/*****************************************************************************//*!
*
* @brief ý
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_DisableRx(UART_Type *pUART)
{    
    pUART->C2 &= (~UART_C2_RE_MASK);
}

/*****************************************************************************//*!
*
* @brief ʹѭģʽ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableLoopback(UART_Type *pUART)
{
    pUART->C1 |= UART_C1_LOOPS_MASK;
    pUART->C1 &= (~UART_C1_RSRC_MASK);
}

/*****************************************************************************//*!
*
* @brief ʹܵģʽ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableSingleWire(UART_Type *pUART)
{
    pUART->C1 |= UART_C1_LOOPS_MASK;
    pUART->C1 |= UART_C1_RSRC_MASK;
}

/*****************************************************************************//*!
*
* @brief 8λģʽ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_Set8BitMode(UART_Type *pUART)
{
    pUART->C1 &= (~UART_C1_M_MASK);
}

/*****************************************************************************//*!
*
* @brief 9λģʽ
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_Set9BitMode(UART_Type *pUART)
{
    pUART->C1 |= UART_C1_M_MASK;
}

/*****************************************************************************//*!
*
* @brief ʹܷͿж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableTxBuffEmptyInt(UART_Type *pUART)
{
    pUART->C2 |= UART_C2_TIE_MASK;
}

/*****************************************************************************//*!
*
* @brief ʹܷж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableTxCompleteInt(UART_Type *pUART)
{
    pUART->C2 |= UART_C2_TCIE_MASK;
}

/*****************************************************************************//*!
*
* @brief ʹܽж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_EnableRxBuffFullInt(UART_Type *pUART)
{
    pUART->C2 |= UART_C2_RIE_MASK;
}

/*****************************************************************************//*!
*
* @brief ÷Ϳж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_DisableTxBuffEmptyInt(UART_Type *pUART)
{
        pUART->C2 &= (~UART_C2_TIE_MASK);    
}

/*****************************************************************************//*!
*
* @brief ôж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_DisableTxCompleteInt(UART_Type *pUART)
{
    pUART->C2 &= (~UART_C2_TCIE_MASK);   
}

/*****************************************************************************//*!
*
* @brief ýж
*        
* @param[in] pUART       ָUARTһĻַ
*
* @return none
*
*****************************************************************************/
__STATIC_INLINE void UART_DisableRxBuffFullInt(UART_Type *pUART)
{
    pUART->C2 &= (~UART_C2_RIE_MASK);  
}

/*****************************************************************************//*!
*
* @brief ͼַ
*        
* @param[in] pUART     ָUARTһĻַ
*
* @return       none
*
*****************************************************************************/
__STATIC_INLINE void UART_PutBreak(UART_Type *pUART)
{
    pUART->C2 |= UART_C2_SBK_MASK; 
    pUART->C2 &= (~UART_C2_SBK_MASK);
}

/*****************************************************************************//*!
*
* @brief ⷢɱ־.
*        
* @param[in] pUART    ָUARTһĻַ
*
* @return       
*               1, ͱ־λ
*               0, ͱ־
*
*****************************************************************************/
__STATIC_INLINE uint8_t UART_IsTxComplete(UART_Type *pUART)
{
    return (pUART->S1 & UART_S1_TC_MASK);
}
/*****************************************************************************//*!
*
* @brief ⷢͼĴǷ
*        
* @param[in] pUART    ָUARTһĻַ
* 
* @return       
*               1, ͼĴ
*               0, ͼĴΪ
*
*****************************************************************************/
__STATIC_INLINE uint8_t UART_IsTxBuffEmpty(UART_Type *pUART)
{
    return (pUART->S1 & UART_S1_TDRE_MASK);
}
/*****************************************************************************//*!
*
* @brief ݼĴǷ
*        
* @param[in] pUART    ָUARTһĻַ
*
* @return       
*               1, ݼĴ
*               0, ݼĴΪ
*
*****************************************************************************/
__STATIC_INLINE uint8_t UART_IsRxBuffFull(UART_Type *pUART)
{
    return (pUART->S1 & UART_S1_RDRF_MASK);
}
/*! @}                                                                        */


/******************************************************************************
******************************************************************************/
void UART_Init(UART_Type *pUART, UART_ConfigType *pConfig);
uint8_t UART_GetChar(UART_Type *pUART);
void UART_PutChar(UART_Type *pUART, uint8_t u8Char);
void UART_SetBaudrate(UART_Type *pUART, UART_ConfigBaudrateType *pConfig);
void UART_EnableInterrupt(UART_Type *pUART, UART_InterruptType InterruptType);
void UART_DisableInterrupt(UART_Type *pUART, UART_InterruptType InterruptType);
uint16_t UART_GetFlags(UART_Type *pUART);
uint8_t UART_CheckFlag(UART_Type *pUART, UART_FlagType FlagType);
void UART_SendWait(UART_Type *pUART, uint8_t *pSendBuff, uint32_t u32Length);
void UART_ReceiveWait(UART_Type *pUART, uint8_t *pReceiveBuff, uint32_t u32Length);
void UART_WaitTxComplete(UART_Type *pUART);
void UART_SetCallback(UART_CallbackType pfnCallback);
void UART0_Isr(void);
void UART1_Isr(void);
void UART2_Isr(void);


#ifdef __cplusplus
}
#endif
#endif /* #ifndef _UART_H_ */
