/**********************************************************************
 *
 * ʵƣSPIշʵ(жϵķʽշ)
 * ʵƽ̨NV32
 * оƬNV32F100FL64E
 * ʵЧSPI͵ͬʱͬݣȽϽպͷ͵ͬж
 *           SPIͨųɹ 
 *
************************************************************************/

#include "common.h"
#include "ics.h"
#include "rtc.h"
#include "uart.h"
#include "spi.h"
#include "systick.h"
#include "spi_app.h"
#include "sysinit.h"


/******************************************************************************
* շݴСSPI
******************************************************************************/
#define SPI0_TX_DATA_SIZE			128
#define SPI_BIT_RATE                1000000     /* ~1Mbps */


static SPI_WidthType gu8SPI0_RxBuff[SPI0_TX_DATA_SIZE];
static SPI_WidthType gu8SPI0_TxBuff[SPI0_TX_DATA_SIZE];
static  uint32_t  gu32ErrorCount    = 0; 
static  uint8_t   gu8Pattern      = 0;
static uint32_t   gu32Loop = 0;

int main (void);

/********************************************************************/
int main (void)
{
	static uint32_t i;
	SPI_ConfigType sSPIConfig = {0};
	PORT->HDRVE = 0x30;
	
		sysinit();
  	printf("\nRunning the SPI_MasterInt_demo project.\r\n");
    LED0_Init();  
    LED2_Init();

    UART_WaitTxComplete(TERM_PORT);   
    
    SPI_InitGlobalVariable(); /*SPIģշͷݳʼ*/
    
    SIM->PINSEL |= SIM_PINSEL_SPI0PS_MASK;  

    /* ʼSPI0λģʽ*/
    sSPIConfig.u32BitRate = SPI_BIT_RATE;  /*ò*/
    sSPIConfig.u32BusClkHz = BUS_CLK_HZ;
    sSPIConfig.sSettings.bModuleEn             = 1; /*!<ʹSPIģ*/
    sSPIConfig.sSettings.bMasterMode           = 1; /*SPIģ*/
    sSPIConfig.sSettings.bClkPhase1            = 0; /*ʱλ*/
    sSPIConfig.sSettings.bMasterAutoDriveSS    = 1; /*!< ӻѡʹ */
   
 
    SPI_Init(SPI0, &sSPIConfig);
    
    gu8Pattern = 0x55;                                 
    /*ʼҪ͵*/
    for(i = 0; i < SPI0_TX_DATA_SIZE; i++)
    {
        gu8SPI0_TxBuff[i] = i+ gu8Pattern;
    }
    
    NVIC_EnableIRQ(SPI0_IRQn);
	while(1)
	{
         /*ʼͺͽ*/
        SPI_Transfer(SPI0,gu8SPI0_RxBuff, gu8SPI0_TxBuff, SPI0_TX_DATA_SIZE);  
        
        /*ȴȫ*/
        while(!(SPI_GetTransferStatus(SPI0) & SPI_STATUS_RX_OVER) );
    
        SPI_ResetTransferStatus(SPI0);

        /*˶ԽյǷȷ*/
        for(i = 0; i < SPI0_TX_DATA_SIZE; i++)
        {
            if(gu8SPI0_RxBuff[i] != gu8SPI0_TxBuff[i])
            {                
                gu32ErrorCount++;
                RED_Init();                     /* */
                break;
            }
        } 

        printf("Error counter is %d\r\n",gu32ErrorCount);

        gu32Loop ++;

        printf("SPI communication counter %d\r\n",gu32Loop);

        for(i=0;i<0xffff;i++);
        
	} 

}

