/******************************************************************************
*
* @brief SPIշ
*
******************************************************************************/
#include "common.h"
#include "spi.h"
#include "spi_app.h"

/******************************************************************************/

static SPI_WidthType *pSPI_RxBuf[MAX_SPI_NO] = {NULL};           /* ָ */
static SPI_WidthType *pSPI_TxBuf[MAX_SPI_NO] = {NULL};           /* ָ */
static uint16_t u16SPI_RxBuffWrPointer[MAX_SPI_NO] = {0};        /* Ԫر */
static uint16_t u16SPI_TxBuffRdPointer[MAX_SPI_NO] = {0};        /* Ԫر */
static uint32_t gu32SPI_BuffSize[MAX_SPI_NO] = {0};              /* С*/
static uint8_t u8SPI_Status[MAX_SPI_NO];


/******************************************************************************/

void SPI0_MasterCallback(void);
void SPI1_MasterCallback(void);


/*****************************************************************************//*!
   *
   * @brief SPIģշͷݳʼ
   *        
   * @param[in]  pSPI     ָSPIģ.
   * @param[in]  pConfig  ָýṹ.
   *
   * @return none.
   *
   *****************************************************************************/
void SPI_InitGlobalVariable( void )
{
    pSPI_RxBuf[0] = NULL;
    pSPI_TxBuf[0] = NULL;
    u16SPI_RxBuffWrPointer[0] = 0;
    u16SPI_TxBuffRdPointer[0] = 0;
    u8SPI_Status[0] = SPI_STATUS_IDLE;          //SPI״̬
    SPI_SetCallback(SPI0,SPI0_MasterCallback); //עSPI0صͨSPI0жϷ

    pSPI_RxBuf[1] = NULL;
    pSPI_TxBuf[1] = NULL;
    u16SPI_RxBuffWrPointer[1] = 0;
    u16SPI_TxBuffRdPointer[1] = 0;
    u8SPI_Status[1] = SPI_STATUS_IDLE;
    SPI_SetCallback(SPI1,SPI1_MasterCallback); //עSPI1صͨSPI1жϷ
}

/*****************************************************************************//*!
   *
   * @brief  SPIշãúôݽͷָݴС
   *        
   * @param[in]   pSPI  ָSPIģ
   * @param[in]   pWrBuff -- ָ. 
   * @param[in]   uiLength --պͷݴС
   * @param[out]   pRdBuff --ָ. 
   * 
   * @return  if <0, means error, 0: success.
   *
   *****************************************************************************/
ResultType SPI_Transfer(SPI_Type *pSPI, SPI_WidthType* pRdBuff, SPI_WidthType * pWrBuff,uint32 u32Length)
{
    uint8_t  iSPI = ((uint32_t)pSPI-(uint32_t)SPI0)>>12;
    ResultType err = SPI_ERR_SUCCESS;
    
    if(!u32Length)
    {
        return (err);
    }
    /*ݽͷָС*/
    gu32SPI_BuffSize[iSPI] = u32Length;  //¼ҪͺͽݴС
    pSPI_RxBuf[iSPI] = pRdBuff;          //ݽָ
    pSPI_TxBuf[iSPI] = pWrBuff;          //ݽָ
    u16SPI_RxBuffWrPointer[iSPI] = 0;    
    u16SPI_TxBuffRdPointer[iSPI] = 0;
    u8SPI_Status[iSPI] = SPI_STATUS_BUSY;
                
    SPI_TxIntEnable(pSPI);         /* ʹܷж*/                
	SPI_IntEnable(pSPI); 
    return (err);        
}

/*****************************************************************************//*!
   *
   * @brief  SPI0 صͨSPI0жϷ
   *        
   * @param[in]   none.
   *
   * @return  none.
   *
   *****************************************************************************/

void SPI0_MasterCallback(void)
{
    /*жϽջǷȡյ*/
    if(SPI_IsSPRF(SPI0))       
    {
    	if( u16SPI_RxBuffWrPointer[0] < gu32SPI_BuffSize[0] )  /*жǷǷȫգ*/
    	{
       		pSPI_RxBuf[0][u16SPI_RxBuffWrPointer[0]++] = SPI_ReadDataReg(SPI0);  /*յݵ*/
        }
       	if (u16SPI_RxBuffWrPointer[0] >= gu32SPI_BuffSize[0]) /*ȫ*/
       	{
       		SPI_ReadDataReg(SPI0);
       		u8SPI_Status[0] |= SPI_STATUS_RX_OVER;
       	}
    }
    /*жϷͻݻǷΪգΪ򽫷дͻ*/
    if(SPI_IsSPTEF(SPI0))
    {
        if(u16SPI_TxBuffRdPointer[0] < gu32SPI_BuffSize[0])   /*жǷȫȫûзд*/
        {
            SPI_WriteDataReg(SPI0,pSPI_TxBuf[0][u16SPI_TxBuffRdPointer[0]++]);  /*дݵͻ*/
        }  
        else
        {
			SPI_TxIntDisable(SPI0);
			u8SPI_Status[0] |= SPI_STATUS_TX_OVER;
        }
    }
    
}
/*****************************************************************************//*!
   *
   * @brief  SPI1 صͨжϷ
   *        
   * @param[in]   none.
   *
   * @return  if <0, means error, 0: success.
   *

   *****************************************************************************/

void SPI1_MasterCallback(void)
{
    /*жϽջǷȡյ*/
    if(SPI_IsSPRF(SPI1))      
    {
    	if( u16SPI_RxBuffWrPointer[1] < gu32SPI_BuffSize[1] )  /*жǷǷȫգ*/
    	{
       		pSPI_RxBuf[1][u16SPI_RxBuffWrPointer[1]++] = SPI_ReadDataReg(SPI1); /*յݵ*/
       	}
       	if( u16SPI_RxBuffWrPointer[1] >= gu32SPI_BuffSize[1] )  /*ȫ*/
       	{
       		SPI_ReadDataReg(SPI1);
      		u8SPI_Status[1] |= SPI_STATUS_RX_OVER;
       	}
    }
    /*жϷͻݻǷΪգΪ򽫷дͻ*/
    if(SPI_IsSPTEF(SPI1))
    {
        if(u16SPI_TxBuffRdPointer[1] < gu32SPI_BuffSize[1])     /*жǷȫȫûзд*/
        {
            SPI_WriteDataReg(SPI1,pSPI_TxBuf[1][u16SPI_TxBuffRdPointer[1]++]);      
        }  
        else
        {
			SPI_TxIntDisable(SPI1);
			u8SPI_Status[1] |= SPI_STATUS_TX_OVER;
        }
    }
}
/*****************************************************************************//*!
   *
   * @brief  ȡ/״̬
   *        
   * @param[in]   pSPI  ָSPIģ.
   *
   * @return  ״̬.
   *
   *****************************************************************************/
uint8_t SPI_GetTransferStatus( SPI_Type *pSPI )
{
	if( pSPI == SPI0 )
    {
        return u8SPI_Status[0];
    }
    else
    {
        return u8SPI_Status[1];
    }
}

/*****************************************************************************//*!
   *
   * @brief  λ/״̬
   *        
   * @param[in]   pSPI  ָSPIģ.
   *
   * @return  none.
   *
   *****************************************************************************/
void SPI_ResetTransferStatus( SPI_Type *pSPI )
{
    if( pSPI == SPI0 )
    {
        u8SPI_Status[0] = SPI_STATUS_IDLE;
    }
    else
    {
        u8SPI_Status[1] = SPI_STATUS_IDLE;
    }
}





